package jp.co.tri_tome.picnickusuri;

import android.app.Activity;
import android.content.Intent;

import java.util.ArrayList;

import me.picnicapp.sdk.content.Content;
import me.picnicapp.sdk.content.ContentLoader;
import me.picnicapp.sdk.map.MapActivity;
import me.picnicapp.sdk.picnic.Picnic;

/**
 * Created by dev on 2016/05/07.
 */
public class AreaSelector {

    private Activity activity;
    private Picnic picnic;

    public AreaSelector(Activity activity) {
        this.activity = activity;
        this.picnic = (Picnic) activity.getApplication();
    }

    public void moveMap23Ku(int which) {
        int targetJson = -1;
        switch (which) {
            case 0:
                targetJson = R.raw.contents_adachi;
                picnic.getSettings().map().setInitialLatitude(35.749747);
                picnic.getSettings().map().setInitialLongitude(139.804436);
                break;
            case 1:
                targetJson = R.raw.contents_arakawa;
                picnic.getSettings().map().setInitialLatitude(35.742699);
                picnic.getSettings().map().setInitialLongitude(139.780616);
                break;
            case 2:
                targetJson = R.raw.contents_itabashi;
                picnic.getSettings().map().setInitialLatitude(35.758812);
                picnic.getSettings().map().setInitialLongitude(139.689657);
                break;
            case 3:
                targetJson = R.raw.contents_edogawa;
                picnic.getSettings().map().setInitialLatitude(35.663405);
                picnic.getSettings().map().setInitialLongitude(139.872873);
                break;
            case 4:
                targetJson = R.raw.contents_oota;
                picnic.getSettings().map().setInitialLatitude(35.562785);
                picnic.getSettings().map().setInitialLongitude(139.715500);
                break;
            case 5:
                targetJson = R.raw.contents_katsushika;
                picnic.getSettings().map().setInitialLatitude(35.746107);
                picnic.getSettings().map().setInitialLongitude(139.856649);
                break;
            case 6:
                targetJson = R.raw.contents_kita;
                picnic.getSettings().map().setInitialLatitude(35.777708);
                picnic.getSettings().map().setInitialLongitude(139.720438);
                break;
            case 7:
                targetJson = R.raw.contents_kouto;
                picnic.getSettings().map().setInitialLatitude(35.669724);
                picnic.getSettings().map().setInitialLongitude(139.817296);
                break;
            case 8:
                targetJson = R.raw.contents_shinagawa;
                picnic.getSettings().map().setInitialLatitude(35.620161);
                picnic.getSettings().map().setInitialLongitude(139.728510);
                break;
            case 9:
                targetJson = R.raw.contents_shibuya;
                picnic.getSettings().map().setInitialLatitude(35.659054);
                picnic.getSettings().map().setInitialLongitude(139.700565);
                break;
            case 10:
                targetJson = R.raw.contents_shinjuku;
                picnic.getSettings().map().setInitialLatitude(35.691039);
                picnic.getSettings().map().setInitialLongitude(139.699105);
                break;
            case 11:
                targetJson = R.raw.contents_suginami;
                picnic.getSettings().map().setInitialLatitude(35.704776);
                picnic.getSettings().map().setInitialLongitude(139.620487);
                break;
            case 12:
                targetJson = R.raw.contents_sumida;
                picnic.getSettings().map().setInitialLatitude(35.697306);
                picnic.getSettings().map().setInitialLongitude(139.813944);
                break;
            case 13:
                targetJson = R.raw.contents_setagaya;
                picnic.getSettings().map().setInitialLatitude(35.643634);
                picnic.getSettings().map().setInitialLongitude(139.671390);
                break;
            case 14:
                targetJson = R.raw.contents_taito;
                picnic.getSettings().map().setInitialLatitude(35.712112);
                picnic.getSettings().map().setInitialLongitude(139.776921);
                break;
            case 15:
                targetJson = R.raw.contents_chuo;
                picnic.getSettings().map().setInitialLatitude(35.669624);
                picnic.getSettings().map().setInitialLongitude(139.767065);
                break;
            case 16:
                targetJson = R.raw.contents_chiyoda;
                picnic.getSettings().map().setInitialLatitude(35.681569);
                picnic.getSettings().map().setInitialLongitude(139.764963);
                break;
            case 17:
                targetJson = R.raw.contents_toshima;
                picnic.getSettings().map().setInitialLatitude(35.729365);
                picnic.getSettings().map().setInitialLongitude(139.711526);
                break;
            case 18:
                targetJson = R.raw.contents_nakano;
                picnic.getSettings().map().setInitialLatitude(35.70579);
                picnic.getSettings().map().setInitialLongitude(139.665376);
                break;
            case 19:
                targetJson = R.raw.contents_nerima;
                picnic.getSettings().map().setInitialLatitude(35.737535);
                picnic.getSettings().map().setInitialLongitude(139.654916);
                break;
            case 20:
                targetJson = R.raw.contents_bunkyo;
                picnic.getSettings().map().setInitialLatitude(35.707345);
                picnic.getSettings().map().setInitialLongitude(139.751240);
                break;
            case 21:
                targetJson = R.raw.contents_minato;
                picnic.getSettings().map().setInitialLatitude(35.628890);
                picnic.getSettings().map().setInitialLongitude(139.738049);
                break;
            case 22:
                targetJson = R.raw.contents_meguro;
                picnic.getSettings().map().setInitialLatitude(35.644313);
                picnic.getSettings().map().setInitialLongitude(139.699065);
                break;
        }

        // 指定のコンテンツを読み込んで地図画面に遷移する
        moveMap(targetJson);
    }

    public void moveMapShityoson(int which) {
        int targetJson = -1;
        switch (which) {
            case 0:
                targetJson = R.raw.contents_z_x0;
                picnic.getSettings().map().setInitialLatitude(35.656391);
                picnic.getSettings().map().setInitialLongitude(139.339557);
                break;
            case 1:
                targetJson = R.raw.contents_z_x1;
                picnic.getSettings().map().setInitialLatitude(35.672482);
                picnic.getSettings().map().setInitialLongitude(139.480202);
                break;
            case 2:
                targetJson = R.raw.contents_z_x2;
                picnic.getSettings().map().setInitialLatitude(35.736658);
                picnic.getSettings().map().setInitialLongitude(139.488377);
                break;
            case 3:
                targetJson = R.raw.contents_z_x3;
                picnic.getSettings().map().setInitialLatitude(35.698697);
                picnic.getSettings().map().setInitialLongitude(139.413507);
                break;
            case 4:
                targetJson = R.raw.contents_z_x4;
                picnic.getSettings().map().setInitialLatitude(35.790222);
                picnic.getSettings().map().setInitialLongitude(139.258385);
                break;
            case 5:
                targetJson = R.raw.contents_z_x5;
                picnic.getSettings().map().setInitialLatitude(33.109845);
                picnic.getSettings().map().setInitialLongitude(139.788923);
                break;
        }

        // 指定のコンテンツを読み込んで地図画面に遷移する
        moveMap(targetJson);
    }

    private void moveMap(int jsonResId) {
        // コンテンツをpicnicSDKに登録する
        ArrayList<Content> contents = ContentLoader.readJsonFromResource(activity, jsonResId);
        picnic.getContentsManager().setContents(contents);
        // 地図画面に遷移する
        Intent intent = new Intent(activity.getApplicationContext(), MapActivity.class);
        activity.startActivity(intent);
        // 記憶しておく
        TinyPref.putInt(this.activity, "jsonResId", jsonResId);
        TinyPref.putFloat(this.activity, "lastLat",  (float) picnic.getSettings().map().getInitialLatitude());
        TinyPref.putFloat(this.activity, "lastLng",  (float) picnic.getSettings().map().getInitialLongitude());
    }

}
